part of insync;

abstract class AbstractCollectionFilterer<V, C extends AbstractCollection<V>> extends Owner {
  Function _filterValue;

  C _source;
  C get source => _source;

  C _target;
  C get target => _target;

  AbstractCollectionFilterer(this._source, {C target, bool filter(V value)}) :
      _filterValue = filter {
    assert(_source != null);
    assert(_filterValue != null);
    _target = (target != null) ? target : _source.createEmpty()..ownBy(this);
  }
}