part of insync;

class ObservableSetHeaper<V> extends AbstractSetHeaper<V> {
  ObservableSetHeaper(ObservableSet<V> source, {AbstractSet<V> target}) :
    super(source, target: target) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(SetSpliceResult<V> spliceResult) {
    _target.trySplice(spliceResult.removedValues, spliceResult.addedValues);
  }

  void _onClear(List<V> values) {
    _target.tryRemoveAll(values);
  }
}