part of insync;

class PropertyCopier<V> extends Owner {
  final Property<V> source;

  Property<V> _target;
  Property<V> get target => _target;

  PropertyCopier(this.source, {Property<V> target}) {
    _target = (target != null) ? target : new Property<V>()..ownBy(this);
    _update();
    own(source.onChange.listen(_update));
  }

  void _update([ValueChangeEventParams<V> p]) {
    _target.value = source.value;
  }
}