part of insync;

class PropertyUpdater<T> extends Owner {
  final List<Property> sources;
  final Function _func;

  PropertyUpdater(this.sources, this._func) {
    _update();
    sources.forEach(watch);
  }

  void listen(EventDispatcher dispatcher) {
    own(dispatcher.listen(_update));
  }

  void watch(Property property) {
    listen(property.onChange);
  }

  void _update([dynamic p]) {
    Function.apply(_func, sources.map((Property source) => source.value).toList());
  }
}