part of insync;

class CheckedListener extends Owner {
  final InputElement el;

  Property<bool> _target;
  Property<bool> get target => _target;

  CheckedListener(this.el, {Property<bool> target}) {
    _target = (target != null) ? target : new Property<bool>()..ownBy(this);
    _update();
    own(new Subscription(el.onChange.listen(_update)));
  }

  void _update([Event event]) {
    _target.value = el.checked;
  }
}