part of insync;

class CheckedUpdater extends Destroyable {
  final InputElement el;
  final Property<bool> property;

  EventAttachment _attachment;

  CheckedUpdater(this.el, this.property) {
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    el.checked = property.value;
  }
}