part of insync;

class TemplateRegistry {
  static Map<String, Template> _cache = new Map<String, Template>();

  static TemplateOutput createElement(String id, String html) {
    Template template = _cache[id];
    if (template == null) {
      template = new Template.html(html);
      _cache[id] = template;
    }
    return template.createElement();
  }
}