part of insync;

class AbstractSetFilterer<V> extends AbstractCollectionFilterer<V, AbstractSet<V>> {
  AbstractSetFilterer(AbstractSet<V> source, {AbstractSet<V> target, bool filter(V value)}) :
    super(source, target: target, filter: filter) {
    _target.tryAddAll(source.set.where(_filterValue).toList(growable: false));
  }

  void destroy() {
    _target.tryRemoveAll(_source.set.toList(growable: false));
    super.destroy();
  }
}