part of insync;

class ConstantList<E> extends WrapList<E> {
  ConstantList(List<E> list) : super(list) {}
  ConstantList.empty() : super.empty() {}

  Iterable map(f(E element)) { _throwUnmodifiable(); }
  void operator []=(int index, E value) => _throwUnmodifiable();
  void set length(int newLength) => _throwUnmodifiable();
  void add(E value) => _throwUnmodifiable();
  void addAll(Iterable<E> iterable) => _throwUnmodifiable();
  void sort([int compare(E a, E b)]) => _throwUnmodifiable();
  void clear() => _throwUnmodifiable();
  void insert(int index, E element) => _throwUnmodifiable();
  void insertAll(int index, Iterable<E> iterable) => _throwUnmodifiable();
  void setAll(int index, Iterable<E> iterable) => _throwUnmodifiable();
  bool remove(Object value) { _throwUnmodifiable(); }
  E removeAt(int index) { _throwUnmodifiable(); }
  E removeLast() { _throwUnmodifiable(); }
  void removeWhere(bool test(E element)) => _throwUnmodifiable();
  void retainWhere(bool test(E element)) => _throwUnmodifiable();
  void setRange(int start, int end, Iterable<E> iterable, [int skipCount = 0]) => _throwUnmodifiable();
  void removeRange(int start, int end) => _throwUnmodifiable();
  void fillRange(int start, int end, [E fillValue]) => _throwUnmodifiable();
  void replaceRange(int start, int end, Iterable<E> iterable) => _throwUnmodifiable();

  void _throwUnmodifiable() {
    throw new UnsupportedError("Cannot modify ConstantList");
  }
}