part of insync;

class ConstantMap<K, V> extends WrapMap<K, V> {
  ConstantMap(Map<K, V> map) : super(map) {}
  ConstantMap.empty() : super.empty() {}

  void operator []=(K key, V value) => _throwUnmodifiable();
  void addAll(Map<K, V> other) => _throwUnmodifiable();
  V putIfAbsent(K key, V ifAbsent()) { _throwUnmodifiable(); }
  V remove(K key) { _throwUnmodifiable(); }
  void clear() => _throwUnmodifiable();
  void forEach(void f(K key, V value)) => _throwUnmodifiable();

  void _throwUnmodifiable() {
    throw new UnsupportedError("Cannot modify ConstantMap");
  }
}