part of insync;

class ObservableMapSorterComparing<K, V> extends AbstractMapSorterComparing<K, V> {
  ObservableMapSorterComparing(ObservableMap<K, V> source, {AbstractList<V> target,
    int compare(V x, V y)}) : super(source, target: target, compare: compare) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(MapSpliceResult<K, V> spliceResult) {
    _splice(
        spliceResult.removedValues.values.toList(growable: false),
        spliceResult.addedValues.values.toList(growable: false));
  }

  void _onClear(Map<K, V> values) {
    _splice(values.values.toList(growable: false), []);
  }
}