part of insync;

class Timeout extends Destroyable {
  Timer _timer;

  Timeout(Duration duration, void callback()) :
    _timer = new Timer(duration, callback);

  Timeout.zero(void callback()) :
    _timer = new Timer(Duration.ZERO, callback);

  Timeout.periodic(Duration duration, void callback()) :
    _timer = new Timer.periodic(duration, (Timer timer) => callback());

  Timeout.adapter(this._timer);

  void destroy() {
    _timer.cancel();
    super.destroy();
  }
}
