part of insync;

class ComponentElements extends WrapMap<String, Element> {
  ComponentElements(Map<String, Element> rawEls) : super(rawEls);

  void operator []=(String key, Element value) {
    if (containsKey(key)) {
      remove(key);
    }
    _map[key] = value;
  }

  Element putIfAbsent(String key, Element ifAbsent()) {
    return new MapUtil<String, Element>().putIfAbsent(this, key, ifAbsent);
  }

  Element remove(String key) {
    Element el = _map.remove(key);
    if (el != null) {
      el.remove();
    }
  }

  void clear() {
    for (Element el in _map.values) {
      el.remove();
    }
    _map.clear();
  }
}