part of insync;

class ClassUpdater extends Destroyable {
  final Element el;
  final String cls;
  final Property<bool> property;

  EventAttachment _attachment;

  ClassUpdater(this.el, this.cls, this.property) {
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    el.classes.toggle(cls, property.value);
  }
}